"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _react2 = _interopRequireDefault(require("@fullcalendar/react"));

var _daygrid = _interopRequireDefault(require("@fullcalendar/daygrid"));

var _timegrid = _interopRequireDefault(require("@fullcalendar/timegrid"));

var _interaction = _interopRequireDefault(require("@fullcalendar/interaction"));

var _bootstrap = _interopRequireDefault(require("@fullcalendar/bootstrap"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const FullCalendarComponent = /*#__PURE__*/_react.default.forwardRef((props, ref) => {
  const pluginsList = {
    'dayGridPlugin': _daygrid.default,
    'timeGridPlugin': _timegrid.default,
    'interactionPlugin': _interaction.default,
    'bootstrapPlugin': _bootstrap.default
  }; // const calenderRef = useRef();
  // const calenderRef = useRef();
  // const getRefernce = () => {
  //   return props.calenderRef ? props.calenderRef : calenderRef;
  // }

  const defaultProps = {
    themeSystem: 'bootstrap',
    plugins: [pluginsList.dayGridPlugin, pluginsList.timeGridPlugin, pluginsList.interactionPlugin],
    headerToolbar: {
      left: 'prev,next today',
      center: 'title',
      right: 'dayGridMonth,timeGridWeek,timeGridDay'
    },
    initialView: 'dayGridMonth',
    businessHours: [{
      daysOfWeek: [0, 1, 2, 3, 4, 5, 6],
      // Monday to Friday
      startTime: '00:00',
      // 8am
      endTime: '23:00' // 6pm

    }],
    droppable: false,
    editable: false,
    selectable: false,
    selectMirror: true,
    dayMaxEvents: true,
    weekends: true,
    events: [],
    initialEvents: [],
    monthDayrRedirect: true,
    eventClick: () => {},
    eventsSet: () => {},
    eventAdd: () => {},
    // (e) => { console.log('event', 'add', e) },
    eventChange: () => {},
    // (e) => { console.log('event', 'change', e) },
    eventRemove: () => {},
    eventDrop: () => {},
    // (e) => { console.log('event', 'drop', e) },
    eventContent: () => {},
    // (dayRenderInfo) => { console.log('day render', dayRenderInfo) },
    dateClick: e => {
      // if (props.monthDayrRedirect || defaultProps.monthDayrRedirect) {
      //   const calendarApi = getRefernce().current.getApi(); // eslint-disable-line
      //   calendarApi.changeView('timeGridDay', e.date);
      // }
      if ((props.monthDayrRedirect || defaultProps.monthDayrRedirect) && ref && ref.current) {
        const calendarApi = ref.current.getApi(); // eslint-disable-line

        calendarApi.changeView('timeGridDay', e.date);
      }
    },
    customButtons: {}
  };

  const getPlugins = () => {
    const selectedPlugin = [];
    props.pluginslist.map(item => {
      if (pluginsList[item]) selectedPlugin.push(pluginsList[item]);
      return item;
    });
    return props.pluginslist && props.pluginslist.length > 0 ? selectedPlugin : defaultProps.plugins;
  };

  const finalProps = _objectSpread(_objectSpread(_objectSpread({}, defaultProps), props), {}, {
    plugins: getPlugins()
  }); // console.log("finalProps", finalProps);


  return /*#__PURE__*/_react.default.createElement("div", {
    className: "calenderWrapper ".concat(finalProps.classWrapper || '')
  }, /*#__PURE__*/_react.default.createElement(_react2.default // ref={getRefernce()}
  , _extends({
    ref: ref
  }, finalProps)));
});

var _default = FullCalendarComponent;
exports.default = _default;